<template>
    <div class="content__leftAnalitika">
        <div class="box-deposit">
            <div class="deposit__top">
                <div class="top__left animated fadeInLeft">
                    <div class="brief_statistics">
                        <svg>
                            <use xlink:href="/img/sprite.svg#pull-down-chart-with-graph33"/>
                        </svg>
                        <p class="text-brief">{{ $t('deposits.short_statistics.title') }}</p>
                    </div>
                    <p class="open-deposit">{{ $t('deposits.short_statistics.opened_sum') }} <span>{{ currencies.formatInDefault(stats.opened_sum) }}</span></p>
                    <p class="text-total">{{ $t('deposits.short_statistics.total_sum') }} <span>{{ currencies.formatInDefault(stats.sum) }}</span></p>
                    <p class="total__brief--deposit">{{ $t('deposits.short_statistics.opened_count') }} <span>{{ stats.hasOwnProperty('opened_count') ? stats.opened_count : 0 }}</span></p>
                </div>
                <div class="top__right animated fadeInRight">
                    <referral-payments-chart :stats="refs"/>
                </div>
            </div>
            <div class="deposit__bottom">
                <div class="bottom__calculate animated fadeInLeft">
                    <p class="text-calculate">{{ $t('deposits.charge_form.title') }}</p>
                    <div class="calculate__input">
                        <label for="percent">{{ $t('deposits.charge_form.percent') }}</label>
                        <input type="number" v-model.number="form.percent" id="percent">
                    </div>
					<div class="calculate__input">
						<label for="plan_id">{{ $t('deposits.charge_form.plan') }}</label>
						<form-select id="plan_id" v-model="form.plan_id" name="plan_id" :options="plansOptions"/>
					</div>
                    <div class="calculate-btn">
                        <a href="#" class="link-goCalculate" @click.prevent="accrual">{{ $t('deposits.charge_form.submit') }}</a>
                        <p class="text-podskazka">{{ $t('deposits.charge_form.help') }}</p>
                    </div>
                </div>
                <deposits-table/>
            </div>
        </div>
</div>
</template>

<script>
import {mapGetters} from 'vuex';
import ReferralPaymentsChart from "../components/charts/ReferralPaymentsChart";
import DepositsTable from "../components/deposits/DepositsTable";
import currencies from "../currencies";
import _ from 'lodash';
import FormSelect from "../components/FormSelect";

export default {
		name: "DepositsPage",
        data(){
		    return {
		        stats: {},
		        plans: [],
                refs: {},
                form: {
		            percent: '',
                    plan_id: undefined,
                },
                deposits_sort: 'id'
            }
        },
        computed: {
		    ...mapGetters([
		        'axios'
            ]),
            currencies: () => currencies,
            plansOptions(){
		        const options = {};
		        _.map(this.plans, (plan) => {
		            options[plan.id] = plan.name;
                });
                return options;
            }
        },
        methods: {
            getPlans(){
                this.axios
                    .get('plans')
                    .then(resp => resp.data)
                    .then(plans => this.plans = plans)
                    .then(() => {
                        if(!this.form.plan_id){
                            if(this.plans.length)
                                this.form.plan_id = this.plans[0].id
                        }
                    });
            },
		    getStats(){
		        this.axios
                    .get('deposits/stats')
                    .then(resp => resp.data)
                    .then(stats => this.stats = stats);
            },
            getRefs(){
                this.axios
                    .get('deposits/refs')
                    .then(resp => resp.data)
                    .then(refs => this.refs = refs);
            },
            accrual(){
                this.axios
                    .post('deposits/customAccrual', this.form)
                    .then((resp) => {
                        let data = resp.data || [];
                        this.$swal('Успешно', `Начисления произведены по ${data.length} депозитам`);
                    })
            }
        },
        mounted() {
		    this.getPlans();
		    this.getStats();
		    this.getRefs();
        },
        components: {
		    ReferralPaymentsChart,
            DepositsTable,
			FormSelect,
        }
    }
</script>

<style scoped>
.calculate__input .form-select{
	width: calc(215px - 22px);
}
</style>
